cache:
  paths:
    - __pycache__
    - .pytest_cache

stages:
  - test
  - create_doc
  - update
  - deploy
  - deploy-docker

before_script:
  - echo "Before script execution"

test:
  image: registry.gitlab.com/plant/plant/no_plant:latest
  stage: test
  tags:
    - linux
  script:
    - export PREV_DIR=$(pwd)
    - cd ..
    - export PYTHONPATH=$(pwd)
    - cd $PREV_DIR/tests
    - pytest --cov-report html:../coverage --cov-report term --cov-config ../.coveragerc --cov=plant test_*
    - cd ..
  artifacts:
    paths:
      - coverage/

create_website_pages:
  image: registry.gitlab.com/plant/plant/no_plant:latest
  stage: create_doc
  script:
    - export PREV_DIR=$(pwd)
    - cd ..
    - export PYTHONPATH=$(pwd)
    - cd $PREV_DIR/website/scripts/
    - bash dump_posts
    - bash dump_notebooks
  artifacts:
    paths:
      - website/
  only:
    - stable

pages:
  image: ruby
  stage: update
  dependencies: 
    - test
    - create_website_pages
  script:
    - cd website/
    - bundle install
    - bundle exec jekyll build -d ../public
    - mv ../coverage/ ../public/coverage
    - ls -R ../public
  artifacts:
    paths:
      - public
    expire_in: 30 days
  only:
    - stable

update_unstable:
  stage: update
  variables:
    GIT_STRATEGY: none
  image: ubuntu
  script:
    - apt-get update && apt-get install --yes git
    - mkdir SSH_clone && cd SSH_clone
    - mkdir -pvm 0700 ~/.ssh
    - echo "$BOT_PRIVATE_RSA" | tr -d '\r' > ~/.ssh/id_rsa
    - chmod 0400 ~/.ssh/id_rsa
    - echo $RSA_KNOWN_HOSTS > ~/.ssh/known_hosts
    - chmod 0400 ~/.ssh/known_hosts
    - git clone git@gitlab.com:plant/plant.git
    - cd plant
    - git checkout origin/unstable
    - git checkout -b unstable --track origin/unstable
    - git config --global user.email "bot@robot.org"
    - git config --global user.name "Bot the robot"
    - git merge --strategy-option theirs -m "Merge branch 'stable' into unstable" stable
    - git push
  only:
    - stable

docker_image:
  stage: deploy-docker
  image: docker:git
  services:
    - docker:dind
  script:
    - docker login -u $BOT_USER -p $BOT_PASS registry.gitlab.com
    - docker build --build-arg DOCKER_TOKEN_USER=${DOCKER_TOKEN_USER} --build-arg DOCKER_TOKEN_PASS=${DOCKER_TOKEN_PASS} -t registry.gitlab.com/plant/plant .
    - docker push registry.gitlab.com/plant/plant
    - docker logout registry.gitlab.com
  environment:
    name: staging-docker
    url: https://gitlab.com/plant/plant
  only: 
    - stable

conda_package:
  stage: deploy
  image: continuumio/anaconda3
  script:
    - cd conda
    - /opt/conda/bin/conda install pandas -y
    - /opt/conda/bin/conda config --set anaconda_upload yes
    - /opt/conda/bin/conda build --token $ANACONDA_TOKEN --output-folder . .
  environment:
    name: staging-conda
    url: https://anaconda.org/PLAnT/plant
  only:
    - stable
